<?php
/**
 * Расширение для интерфейса "Заказы"
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}

class Order_paygine_admin_order extends Diafan
{
	const MODULE_NAME = 'paygine';
	public $is_paygine = false;
	public function __construct(&$diafan)
	{
		$payment_id = (int) DB::query_result("SELECT `payment_id` FROM {payment_history} WHERE `element_id`=%d LIMIT 1", $diafan->id);
		$pg_payment_name = DB::query_result("SELECT `payment` FROM {payment} WHERE `id`=%d AND `trash`='0' LIMIT 1", $payment_id);
		if($payment_id && ($pg_payment_name === self::MODULE_NAME))
			$this->is_paygine = true;
		$module_path = 'modules/payment/backend/'. self::MODULE_NAME .'/payment.'. self::MODULE_NAME .'.lib.php';
		if(Custom::exists($module_path)){
			include_once(Custom::path($module_path));
			$this->paygine = new Paygine($diafan, $payment_id);
		}
		
		parent::__construct($diafan);
	}
	/**
	 * Редактирвание поля расширения
	 *
	 * @return void
	 */
	public function edit()
	{
		if($this->diafan->is_new || !$this->is_paygine)
			return;
		
		$pc_order_params = $this->paygine->getPcOrderParamsByOrderId($this->diafan->id);
		if(!$pc_order_params){
			
			$status_id = DB::query_result("SELECT status_id FROM {shop_order} WHERE id=%d LIMIT 1", $this->diafan->id);
			if(!empty($this->paygine->notify_customer) && !empty($this->paygine->order_agreement) && $this->paygine->order_agreement === $status_id){
				$details = $this->diafan->_order->details($this->diafan->id);
				if(!empty($details['email'])){
					echo '<div class="unit">
							<a class="btn btn_blue btn_small btn_dwnl" href="'.BASE_PATH.'payment/get/paygine/'.$this->diafan->id.'/confirm">Отправить счет на оплату</a>
						</div>';
				} else {
					echo '<span style="color: red">Для отправки счета добавьте Email</span>';
				}
			}
		
		} else {
			
			echo '<div class="unit">';
			if($pc_order_params['order_state'] === Paygine::ORDER_AUTHORIZED && (empty($pc_order_params['loan']) || $pc_order_params['loan_type'] === Paygine::VSEGDADA)){
				echo '<a class="btn btn_blue btn_small btn_dwnl" href="'.BASE_PATH.'payment/get/paygine/'.$this->diafan->id.'/complete">Списать средства</a>';
			}
			if($pc_order_params['order_state'] === Paygine::ORDER_AUTHORIZED || $pc_order_params['order_state'] === Paygine::ORDER_COMPLETED){
				echo '<a class="btn btn_blue btn_small" href="'.BASE_PATH.'payment/get/paygine/'.$this->diafan->id.'/refund">Отменить оплату</a>';
			}
			echo '</div>';
			
		}
	}
	
}