<?php

include_once 'payment.paygine.lib.php';

Paygine::checkCms();

class Payment_paygine_admin
{
	public $config;
	private $diafan;
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;
		$this->config = array(
			'name' => 'Paygine',
			'params' => array(
				'paygine_sector' => 'Номер сектора',
				'paygine_password' => 'Пароль',
				'paygine_test' => array(
					'name' => 'Тестовый режим',
					'type' => 'checkbox'
				),
				'paygine_payment_type' => array(
					'name' => 'Способ оплаты',
					'type' => 'select',
					'select' => Paygine::PAYMENT_TYPES,
				),
				'paygine_tax' => array(
					'name' => 'Ставка НДС',
					'type' => 'select',
					'select' => Paygine::TAX,
				),
				'paygine_hash_algo' => array(
					'name' => 'Алгоритм шифрования данных',
					'type' => 'select',
					'select' => Paygine::HASH_ALGO,
					'help' => 'Должен совпадать с настройками шифрования сектора в вашем личном кабинете',
				),
				'paygine_redirect' => array(
					'name' => 'Автоматически переходить на страницу оплаты',
					'type' => 'checkbox',
					'help' => 'После подтверждения заказа на странице корзины, переход на страницу оплаты произойдет автоматически',
				),
				'paygine_modal' => array(
					'name' => 'Открывать пейформу в модальном окне',
					'type' => 'checkbox',
					'help' => 'При включенной опции форма оплаты открывается в модальном окне. Работает только при выборе следующих способов оплаты: Эквайринг, СБП, Плайт',
				),
				'paygine_notify_url' => array('type' => 'function'),
				'paygine_order_status_title' => array(
					'name' => 'Настраиваемые статусы заказов',
					'type' => 'title'
				),
				'paygine_order_registered' => array(
					'name' => 'Заказ зарегистрирован',
					'type' => 'select',
					'select' => Paygine::orderStatusesList(),
				),
				'paygine_order_authorized' => array(
					'name' => 'Средства захолдированы',
					'type' => 'select',
					'select' => Paygine::orderStatusesList(),
				),
				'paygine_order_loan' => array(
					'name' => 'Кредитный договор одобрен, но не подписан',
					'type' => 'select',
					'select' => Paygine::orderStatusesList(),
				),
				'paygine_order_completed' => array(
					'name' => 'Заказ успешно оплачен',
					'type' => 'select',
					'select' => Paygine::orderStatusesList(),
				),
				'paygine_order_canceled' => array(
					'name' => 'Заказ отменен',
					'type' => 'select',
					'select' => Paygine::orderStatusesList(),
				),
				'paygine_notify_customer' => array(
					'name' => 'Отправка счета на оплату после согласования заказа',
					'type' => 'checkbox',
					'help' => 'При включенной опции заказ будет создан со статусом "На согласовании". Администратор проверяет заказ и отправляет счет на оплату(кнопка в заказе), при этом статус заказа меняется на "Ожидается оплата"',
				),
				'paygine_script' => array('type' => 'function'),
				'paygine_order_agreement' => array(
					'name' => 'На согласовании',
					'type' => 'select',
					'select' => Paygine::orderStatusesList(false),
				),
				'paygine_order_waiting_payment' => array(
					'name' => 'Ожидается оплата',
					'type' => 'select',
					'select' => Paygine::orderStatusesList(false),
				),
			)
		);
	}
	
	public function edit_variable_paygine_notify_url()
	{
		$text = <<<FIELD
			<div class="unit" depend="backend=paygine" payment="paygine" style="display:none">
				<div class="infofield">
					URL для уведомлений <i class="tooltip fa fa-question-circle" title="Скопируйте и вставьте в соответствующее поле в Вашем Личном кабинете в системе Paygine"></i>
				</div>
				<input readonly value="%spayment/get/paygine?callback=true">
			</div>
FIELD;
		echo sprintf($text, BASE_PATH);
	}
	
	public function edit_variable_paygine_script($r)
	{
		echo <<<FIELD
<script type="text/javascript">
	const pg_notify_customer = document.getElementById("input_paygine_paygine_notify_customer");
	const pg_order_agreement = document.getElementsByName("paygine_paygine_order_agreement");
	const pg_order_waiting_payment = document.getElementsByName("paygine_paygine_order_waiting_payment");
	window.addEventListener("load", (event) => {
		status_display_switcher(pg_notify_customer.checked);
	});
	pg_notify_customer.addEventListener("change", (event) => {
		status_display_switcher(event.target.checked);
	});
	function status_display_switcher(switcher){
		if(switcher === true){
			pg_order_agreement.forEach(element => {
				element.parentElement.style.display = "block";
			})
			pg_order_waiting_payment.forEach(element => {
				element.parentElement.style.display = "block";
			})
		} else {
			pg_order_agreement.forEach(element => {
				element.parentElement.style.display = "none";
			})
			pg_order_waiting_payment.forEach(element => {
				element.parentElement.style.display = "none";
			})
		}
	}
</script>
<script type="text/javascript">
	var payment_type = document.getElementsByName("paygine_paygine_payment_type")[0];
	var modal_payform = document.getElementsByName("paygine_paygine_modal")[0];
	
	modal_payform_switcher(payment_type.value);
	payment_type.addEventListener("change", (event) => {
		modal_payform_switcher(event.target.value);
	});
	function modal_payform_switcher(payment_type_value){
		if(payment_type_value == "loan"){
			modal_payform.checked = false;
			modal_payform.disabled = true;
		} else {
			modal_payform.disabled = false;
		}
	}
</script>
FIELD;
	}
}